// -------------------------------------------------------------------------------
// Gregorian Week Number. Kalenderwoche.
function ISO8601_week_no(dt) {
var tdt = new Date(dt.valueOf());
var dayn = (dt.getDay() + 6) % 7;
tdt.setDate(tdt.getDate() - dayn + 3);
var firstThursday = tdt.valueOf();
tdt.setMonth(0, 1);
if (tdt.getDay() !== 4)
{
tdt.setMonth(0, 1 + ((4 - tdt.getDay()) + 7) % 7);
}
return 1 + Math.ceil((firstThursday - tdt) / 604800000);
}

dt = new Date();
//console.log(ISO8601_week_no(dt));
var gregdateweeknumber = ISO8601_week_no(dt);

//dt = new Date(2015, 10, 1);
//console.log(ISO8601_week_no(dt));

// https://www.w3resource.com/javascript-exercises/javascript-date-exercise-24.php
// -------------------------------------------------------------------------------


//
// © Volka Polka — penultima.de. All rights reserved.
//

// Gregorian-Datum
function aktuellesgregoriandatum() {
var newdatevalue = new Date();
var options = { weekday: 'long', year: 'numeric', month: '2-digit', day: '2-digit' };
var gregdate = newdatevalue.toLocaleDateString('en-US', options);
document.getElementById("dividgregdatumjetzt").innerHTML = "<u>" + gregdate + " (en-US)<br>calendar week: " + gregdateweeknumber + "</u>";
}
aktuellesgregoriandatum();
setInterval(function(){
aktuellesgregoriandatum();
}, 1000);



// DEZIMAL-KALENDER

function dezimalkalendertabelle() {
// INFO
// 31536000 = Sekunden pro Jahr
// 86400 = Sekunden pro Tag
// 3600 = Sekunden pro Stunde
// Timestamp20000000 20000101-00:00:00UTC = 946684800
// Timestamp19991223 19991223-00:00:00UTC = 945907200
// Differenz: Timestamp20000000 - Timestamp19991223 = 777600

// Timestamp in Millisekunden
var timestampnow = Date.now();

// ZEITZONEN-KORREKTUR (* 1000 = Millisekunden)
var zeitzonestundentoUTC = 1;
timestampnow = timestampnow + (zeitzonestundentoUTC * (3600 * 1000))

// Timestamp in Sekunden
var timestampnowseconds = Math.floor(timestampnow / 1000);
var newdate = new Date(timestampnow);

// Schaltjahre von 1970 bis 2000 = 7
var schaltjahrevon1970bis2000 = Math.floor((2000 - 1970) / 4);

// Sekunden ab 23.12.1999 00:00:00 UTC
var sekunden1970bis19991223 = (((31536000 * (2000 - 1970)) + (schaltjahrevon1970bis2000 * 86400)) - (86400 * 9));
var sekundenseit19991223 = (timestampnowseconds - sekunden1970bis19991223);

// Bereinigen der Timestamp-Sekunden wegen 19991223 anstatt 20000000.
var schaltjahreseit19991223aaa = ((sekundenseit19991223 / 31536000));
var schaltjahreseit19991223bbb = Math.floor(schaltjahreseit19991223aaa) / 4;
var schaltjahreseit19991223ccc = Math.floor(schaltjahreseit19991223bbb) + 1;
var schaltjahreseit19991223ddd = schaltjahreseit19991223ccc * 86400;
var schaltjahreseit19991223eee = sekundenseit19991223 - schaltjahreseit19991223ddd;
var schaltjahreseit19991223fff = (schaltjahreseit19991223eee) / 31536000;
var schaltjahreseit19991223ggg = Math.floor(schaltjahreseit19991223fff) / 4;
var schaltjahreseit19991223hhh = Math.floor(schaltjahreseit19991223ggg) + 1;
var jahreseit19991223clean = Math.floor(schaltjahreseit19991223fff);
var schaltjahreseit19991223 = schaltjahreseit19991223hhh;
var schaltjahrsekundenseit19991223 = schaltjahreseit19991223 * 86400;

// DEZIMAL-JAHR
var dezimaljahrnow = jahreseit19991223clean;
//console.log( dezimaljahrnow );
//document.getElementById("dividjahr").innerHTML = dezimaljahrnow;

// DEZIMAL-WOCHE
var dezimalwochenow = Math.floor((((sekundenseit19991223 - schaltjahrsekundenseit19991223) - ((31536000 * dezimaljahrnow) )) / 86400) / 10);
//console.log( ((((sekundenseit19991223 - schaltjahrsekundenseit19991223) - ((31536000 * dezimaljahrnow) )) / 86400) / 10) );
//document.getElementById("dividwoche").innerHTML = dezimalwochenow;

// DEZIMAL-TAG
var dezimaltagnow = Math.floor((((((sekundenseit19991223 - schaltjahrsekundenseit19991223) - ((31536000 * dezimaljahrnow) )) / 86400))) % 10);
//console.log( ((((((sekundenseit19991223 - schaltjahrsekundenseit19991223) - ((31536000 * dezimaljahrnow) )) / 86400))) % 10) );
dezimaltagnow = dezimaltagnow + 1;
if (dezimaltagnow > 9) {
dezimaltagnow = (dezimaltagnow + 1) - 11;
dezimalwochenow = dezimalwochenow + 1;
}
if (((((dezimaljahrnow + 1) / 4) % 1) === 0) && (dezimalwochenow === 36) && (dezimaltagnow === 6)) {
dezimaljahrnow = dezimaljahrnow + 1;
dezimalwochenow = 0;
dezimaltagnow = 0;
}

// HTML AUSGABEN

// DEZIMAL-DATUM Konstruktion WW.DD.YY
document.getElementById("dividjahrwochetag").innerHTML = leadzero(dezimaljahrnow) + "-" + leadzero(dezimalwochenow) + "-" + leadzero(dezimaltagnow);

// DEZIMAL-DATUM Konstruktion DW.
document.getElementById("dividtagimjahr").innerHTML = dezimalwochenow + "" + dezimaltagnow + ". Day in Year";


// DEZIMAL-KALENDER-TABELLEN
var tablefull = "";
var classheutejahr = "";
var classheutewoche = "";
var classheutetag = "";

// Tabellen-Spalten-Anzahl
var tabletdanzahl = 11;
// Tabellen-Head-colspan
var theadthcolspan = 3;
// Tabellen-Foot-colspan
var tfoottdcolspan = tabletdanzahl;

for (var i = ((dezimaljahrnow) - 0); i < ((dezimaljahrnow) + 1); i++) {

if (i === dezimaljahrnow) {
classheutejahr = " tdclassnow";
} else {
classheutejahr = "";
}

tablefull += '<div class="divclasstable">';
tablefull += "\n";

tablefull += "<table>";
tablefull += "\n";

tablefull += "<thead>";
tablefull += "\n";

tablefull += "<tr>";

for (var h = 0; h < (tabletdanzahl - (theadthcolspan - 1)); h++) {
if (h < 1) {
tablefull += '<th class="' + classheutejahr + '" colspan="' + theadthcolspan + '">';
tablefull += "Jahr " + i;
tablefull += "</th>";
} else {
tablefull += '<th class="">';
tablefull += "";
tablefull += "</th>";
}
}

tablefull += "</tr>";
tablefull += "\n";

tablefull += "</thead>";
tablefull += "\n";

tablefull += "<tbody>";
tablefull += "\n";

for (var ii = 0; ii < 37; ii++) {

if ((i === dezimaljahrnow) && (ii === dezimalwochenow)) {
classheutewoche = " tdclassnow";
} else {
classheutewoche = "";
}

tablefull += "<tr>";

tablefull += '<td class="woche' + classheutewoche + '">';
tablefull += ii;
tablefull += "</td>";

for (var iii = 0; iii < 10; iii++) {

if ((i === dezimaljahrnow) && (ii === dezimalwochenow) && (iii === dezimaltagnow)) {
classheutetag = " tdclassnow";
} else {
classheutetag = "";
}

if (((((i) / 4) % 1) === 0) && (ii === 0) && (iii === 0)) {
tablefull += '<td class="schaltjahr' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
} else if (((((i) / 4) % 1) !== 0) && (ii === 0) && (iii === 0)) {
tablefull += '<td class="' + classheutetag + '">';
tablefull += "";
tablefull += "</td>";
} else if ((ii === 36) && (iii > 5)) {
tablefull += '<td class="' + classheutetag + '">';
tablefull += "";
tablefull += "</td>";
} else if ((ii === 0) && (iii > 0)) {
tablefull += '<td class="jahresanfang' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
} else if (iii === 0) {
tablefull += '<td class="nullinger' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
} else if (iii === 8) {
tablefull += '<td class="achter' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
} else if (iii === 9) {
tablefull += '<td class="neuner' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
} else {
tablefull += '<td class="' + classheutetag + '">';
tablefull += iii;
tablefull += "</td>";
}

}

tablefull += "</tr>";
tablefull += "\n";

}

tablefull += "</tbody>";
tablefull += "\n";

tablefull += "<tfoot>";
tablefull += "\n";

tablefull += "<tr>";

for (var f = 0; f < (tabletdanzahl - (tfoottdcolspan - 1)); f++) {
if (f < 1) {
tablefull += '<td class="" colspan="' + tfoottdcolspan + '">';
tablefull += "Use at you own risk.";
tablefull += "</td>";
} else {
tablefull += '<td class="">';
tablefull += "";
tablefull += "</td>";
}
}
tablefull += "</tr>";
tablefull += "\n";

tablefull += "</tfoot>";
tablefull += "\n";

tablefull += "</table>";
tablefull += "\n";

tablefull += "</div>";
tablefull += "\n";

}

console.log(tablefull);

document.getElementById("dividdezimalkalender").innerHTML = tablefull;

}

dezimalkalendertabelle();

setInterval(function(){
dezimalkalendertabelle();
}, 1000);

function leadzero(digitvalue) { if (digitvalue < 10) digitvalue = "0" + digitvalue; return digitvalue; }